from visual import *

print """
Change inclination of dumbel and
rotation rate with the sliders
Blue vectors: Velocity
Red Vector: Angular Momentum
"""

grey = (0.85, 0.85, 0.85)

class slider:
    def __init__(self, pos=vector(0,0,0), axis=vector(0,1.,0), value=None,
                 width=0.15, min=0, max=100., color=(1,0,0)):
        pos = vector(pos)
        #axis = vector(axis)
        if value == None:
            value = min
        self.min = min
        self.max = max
        self.value = value
        self.shaft = cylinder(pos=pos, axis=axis, radius=width/4., color=grey)
        self.start = pos
        self.axis = axis
        self.control = sphere(pos=self.start+(self.min+value)/(self.max-self.min)*self.axis,
                        radius=width/2., color = color)
        self.control.label = "%0.2f" % value

    def getslider(self, pos=None):
        pos = vector(pos)
        value = self.min+(self.max-self.min)*dot(pos, self.axis)
        self.setslider(value)
        return value

    def setslider(self, value=None):
        if value > self.max:
            value = self.max
        if value < self.min:
            value = self.min
        self.value = value
        self.control.pos = self.start+(self.min+value)/(self.max-self.min)*self.axis
        self.control.label = "%0.2f" % value

def veclength(freq=50,phi=60):
    phi=phi/180*pi
    lfactor=freq*cos(phi)/100
    lll=Lveclength*lfactor
    vvv=vveclength*lfactor
    Lvec.axis=(0,lll,0)
    vec1.axis=(0,0,vvv)
    vec2.axis=(0,0,-vvv)
    
    
    
scene.visible=0
scene.width = 600
scene.height = 600
scene.x = 10
scene.y = 10
scene.center = (0,0.5,0)
scene2 = display(title='Settings', width=300, height=600,
                center=(0,0.5,0), background=(0,1,1),
                                 x=scene.width+scene.x+5, y=scene.y)
scene.visible=0
scene2.visible=0


scene.select()          # Main Window
scene.title = "Rotating Dumbell"
scene.background=(.8,.8,.8)

# Generate Objects
table = box(pos=(0,-.05,0), length=1, height=0.1, width=1, color=(0.5,0.5,0.1))

#Rod from small cylinders
dy=0.05
nrdy=1/dy
xmax=0.05
RodFrame=frame()
RodFrame.axis=(1,0,0)
RodFrame.pos=(0,0,0)

suppcurve=[cylinder(pos=(0,0,0), axis=(0,dy,0), radius=0.02, color=grey)]
for yindex in range(1, int(nrdy)):                                                   #build rod out of small cylinders
    ycurve=yindex*dy
    x_of_y=xmax*ycurve**4
    dx=4*xmax*ycurve**3*dy
    suppcurve.append(cylinder(pos=(x_of_y,ycurve,0), axis=(dx,dy,0), 
                        radius=0.02, color=grey))
                        
for yindex in range(0,int(nrdy)):
    suppcurve[yindex].frame=RodFrame                                            #and put them into the same frame


# define Dumbel
hLength=.8
hpos=vector(vector(-0.5*hLength,0,0))
hvec=vector(hLength, 0, 0)
DumbelRod=cylinder(pos=hpos, axis=hvec, radius=0.02, color=(0.7,0.7,0.7))

#Cylinders of Dumbel
m1axis=DumbelRod.axis*0.2
m1=cylinder(pos=DumbelRod.pos - 0.5*m1axis, axis=m1axis, radius=0.1*mag(DumbelRod.axis), color = (0.5,0.4,0.7))
m2=cylinder(pos=DumbelRod.pos - 0.5*m1axis, axis=m1axis, radius=0.1*mag(DumbelRod.axis), color = (0.5,0.4,0.7))
m2.pos=m1.pos+DumbelRod.axis

#Vectors L and v
Lveclength=1.2
vveclength=0.8
Lvec=arrow(pos=(0,0,0), axis=(0,Lveclength,0), color = (1,0,0), shaftwidth = 0.04)
vec1=arrow(pos=DumbelRod.pos, axis=(0,0,vveclength), color = (0,0,1), shaftwidth = 0.025)
vec2=arrow(pos=DumbelRod.pos+hvec, axis=(0,0,-vveclength), color = (0,0,1),shaftwidth = 0.025)

#Dumbel and Vectors to a list
DumbelAndVec=[DumbelRod, m1, m2, Lvec, vec1, vec2]

#Alles bewegliche zu einem Frame
DumbelFrame=frame()
DumbelFrame.axis=(1,0,0)
DumbelFrame.pos=(xmax,1,0)
for x in DumbelAndVec:
    x.frame=DumbelFrame

            
#scene2: Slider
scene2.select()
ctrl = [slider(pos=(-0.2,0,0), color=(1,0,0), min = 1., max=150., value=75.),
        slider(pos=(0.2,0,0) , color=(0,1,0), max=89.9, value=60.)]
scene2.autoscale=1
omegalabel= label(pos=ctrl[0].start+ctrl[0].axis/2, text='omega', xoffset=0, yoffset=-10,
                    space=0.2, height=12, border=2)
thetalabel= label(pos=ctrl[1].start+ctrl[0].axis/2, text='theta (deg)', xoffset=0, yoffset=-10,
                    space=0.2, height=12, border=2)
scene2.autoscale=1

scene.select()

#Start geometry
rotangle=ctrl[1].value/180*pi
DumbelFrame.rotate(angle=rotangle, axis=(0,0,1))
veclength(freq=ctrl[0].value, phi=ctrl[1].value)

phirad=ctrl[1].value/180*pi
xmaxphi=sin(2*phirad)
xmaxact=xmax* ((ctrl[0].value/ctrl[0].max)*xmaxphi)**3
for yindex in range(0, int(nrdy)):
    ycurve=yindex*dy
    x_of_y=xmaxact*ycurve**4
    dx=4*xmaxact*ycurve**3*dy
    suppcurve[yindex].pos=(x_of_y,ycurve,0)
    suppcurve[yindex].axis=(dx,dy,0)
faxis_xz=vector(DumbelFrame.axis[0],0,DumbelFrame.axis[2])/((DumbelFrame.axis[0]**2 + DumbelFrame.axis[2]**2)**0.5)
DumbelFrame.pos=faxis_xz*xmaxact + vector(0,1,0)




scene.visible=1
scene2.visible=1
scene.autoscale=0
scene2.autoscale=0
scene2.userzoom=0
scene2.userspin=0
dragging=False
rotrate=ctrl[0].value
DumbelFrame.rotate(angle=0.1, axis=(0,1,0), origin=(0,1,0))
RodFrame.rotate(angle=0.1, axis=(0,1,0), origin=(0,1,0))
posi=vector(0,0,0)
Ctrl0Picked=False
newpos=vector(0,0,0)

while 1:
    rate(rotrate)
    DumbelFrame.rotate(angle=0.1, axis=(0,1,0), origin=(0,1,0))
    RodFrame.rotate(angle=0.1, axis=(0,1,0), origin=(0,1,0))
    if scene2.mouse.events:
        m = scene2.mouse.getevent()
        if m.drop=="left":
                    dragging=False
        if m.drag=="left" and (m.pick is ctrl[0].control):              #rot rate slider
                Ctrl0Picked=True
                posi = m.project(normal=(0,0,1))
                dragging=True

        if m.drag=="left" and (m.pick is ctrl[1].control):              #angle of dumbell
            Ctrl0Picked=False
            posi = m.project(normal=(0,0,1))
            dragging=True
 
    newpos=scene2.mouse.project(normal=(0,0,1))
    
    if ((newpos!=posi) and dragging) and Ctrl0Picked:
        ctrl[0].getslider(posi)
        posi=newpos



    if ((newpos!=posi) and dragging) and not(Ctrl0Picked):
        ctrl[1].getslider(posi)
        posi=newpos


    #change v,L vectors and adjust bending of rod to torque that depends on rotation rate and angle
    # The bending is not numerically but just visually correct
    
    if dragging:
        rotrate=ctrl[0].value
        rotangle=(ctrl[1].value)/180*pi     

        faxis=DumbelFrame.axis                                  #rotate from current position to have smooth updates
        phi=-acos(faxis.x/pow((faxis.x*faxis.x+faxis.z*faxis.z),0.5))
        if faxis.z < 0:
            phi=-phi
        faxis=(1,0,0)
        fup=(0,1,0)
        faxis=rotate(faxis,angle=rotangle, axis=(0,0,1))        #rotiere Startvektoren
        fup=rotate(fup,angle=rotangle, axis=(0,0,1))
        DumbelFrame.axis=rotate(faxis,angle=phi, axis=(0,1,0))  #und schreibe nachher
        DumbelFrame.up=rotate(fup,angle=phi, axis=(0,1,0))      #in frame
                        
        veclength(freq=ctrl[0].value, phi=ctrl[1].value)        #adjust vectorlength
        phirad=ctrl[1].value/180*pi
        xmaxphi=sin(2*phirad)
        xmaxact=xmax* ((ctrl[0].value/ctrl[0].max*2)*xmaxphi)**3
        for yindex in range(0, int(nrdy)):
            ycurve=yindex*dy
            x_of_y=xmaxact*ycurve**4
            dx=4*xmaxact*ycurve**3*dy
            suppcurve[yindex].pos=(x_of_y,ycurve,0)
            suppcurve[yindex].axis=(dx,dy,0)
        faxis_xz=vector(DumbelFrame.axis[0],0,DumbelFrame.axis[2])/((DumbelFrame.axis[0]**2 + DumbelFrame.axis[2]**2)**0.5)
        DumbelFrame.pos=faxis_xz*xmaxact + vector(0,1,0)
       
                    
